#ifndef _AES_H
#define _AES_H

#include <stdint.h>

#define Nk  8

#if Nk == 4
#define Nr  10
#elif Nk == 6
#define Nr  12
#elif Nk == 8
#define Nr  14
#else
#error "Nk must be 4, 6 or 8"
#endif

#define Nrk (4*(Nr+1))

extern void aes_expand_key(uint32_t w[Nrk], const void *key);
extern void aes_expand_dkey(uint32_t dw[Nrk], const uint32_t w[Nrk]);
extern void aes_encrypt_block(void *d, const void *p, const uint32_t w[Nrk]);
extern void aes_decrypt_block(void *d, const void *p, const uint32_t w[Nrk]);

#endif

